/*----- PROTECTED REGION ID(PLCsocketClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        PLCsocketClass.h
//
// description : Include for the PLCsocket root class.
//               This class is the singleton class for
//                the PLCsocket device class.
//               It contains all properties and methods which the 
//               PLCsocket requires only once e.g. the commands.
//
// project :     PLC interlock server
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: graziano $
//
// $Revision: 1.7 $
// $Date: 2017-02-23 08:42:46 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef PLCsocketClass_H
#define PLCsocketClass_H

#include <tango.h>
#include <PLCsocket.h>

/*----- PROTECTED REGION END -----*/	//	PLCsocketClass.h


namespace PLCsocket_ns
{
/*----- PROTECTED REGION ID(PLCsocketClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	PLCsocketClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute IThreshold class definition
class IThresholdAttrib: public Tango::Attr
{
public:
	IThresholdAttrib():Attr("IThreshold",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~IThresholdAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCsocket *>(dev))->read_IThreshold(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCsocket *>(dev))->is_IThreshold_allowed(ty);}
};

//	Attribute Libera3hc class definition
class Libera3hcAttrib: public Tango::Attr
{
public:
	Libera3hcAttrib():Attr("Libera3hc",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~Libera3hcAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCsocket *>(dev))->read_Libera3hc(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCsocket *>(dev))->is_Libera3hc_allowed(ty);}
};

//	Attribute BeamDumpPLCA10 class definition
class BeamDumpPLCA10Attrib: public Tango::Attr
{
public:
	BeamDumpPLCA10Attrib():Attr("BeamDumpPLCA10",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~BeamDumpPLCA10Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCsocket *>(dev))->read_BeamDumpPLCA10(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCsocket *>(dev))->is_BeamDumpPLCA10_allowed(ty);}
};

//	Attribute BeamAbi class definition
class BeamAbiAttrib: public Tango::Attr
{
public:
	BeamAbiAttrib():Attr("BeamAbi",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~BeamAbiAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCsocket *>(dev))->read_BeamAbi(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCsocket *>(dev))->is_BeamAbi_allowed(ty);}
};

//	Attribute CallPm class definition
class CallPmAttrib: public Tango::Attr
{
public:
	CallPmAttrib():Attr("CallPm",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~CallPmAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCsocket *>(dev))->read_CallPm(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCsocket *>(dev))->is_CallPm_allowed(ty);}
};

//	Attribute AlIThreshold class definition
class AlIThresholdAttrib: public Tango::Attr
{
public:
	AlIThresholdAttrib():Attr("AlIThreshold",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~AlIThresholdAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCsocket *>(dev))->read_AlIThreshold(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCsocket *>(dev))->is_AlIThreshold_allowed(ty);}
};

//	Attribute AlLibera3hc class definition
class AlLibera3hcAttrib: public Tango::Attr
{
public:
	AlLibera3hcAttrib():Attr("AlLibera3hc",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~AlLibera3hcAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCsocket *>(dev))->read_AlLibera3hc(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCsocket *>(dev))->is_AlLibera3hc_allowed(ty);}
};

//	Attribute Seq_state class definition
class Seq_stateAttrib: public Tango::Attr
{
public:
	Seq_stateAttrib():Attr("Seq_state",
			Tango::DEV_STRING, Tango::READ) {};
	~Seq_stateAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCsocket *>(dev))->read_Seq_state(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCsocket *>(dev))->is_Seq_state_allowed(ty);}
};

//	Attribute EnableBPM11_2 class definition
class EnableBPM11_2Attrib: public Tango::Attr
{
public:
	EnableBPM11_2Attrib():Attr("EnableBPM11_2",
			Tango::DEV_BOOLEAN, Tango::READ) {};
	~EnableBPM11_2Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCsocket *>(dev))->read_EnableBPM11_2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCsocket *>(dev))->is_EnableBPM11_2_allowed(ty);}
};

//	Attribute OpenId class definition
class OpenIdAttrib: public Tango::SpectrumAttr
{
public:
	OpenIdAttrib():SpectrumAttr("OpenId",
			Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~OpenIdAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCsocket *>(dev))->read_OpenId(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCsocket *>(dev))->is_OpenId_allowed(ty);}
};

//	Attribute DiodeDet class definition
class DiodeDetAttrib: public Tango::SpectrumAttr
{
public:
	DiodeDetAttrib():SpectrumAttr("DiodeDet",
			Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~DiodeDetAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCsocket *>(dev))->read_DiodeDet(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCsocket *>(dev))->is_DiodeDet_allowed(ty);}
};

//	Attribute LiberaSt class definition
class LiberaStAttrib: public Tango::SpectrumAttr
{
public:
	LiberaStAttrib():SpectrumAttr("LiberaSt",
			Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~LiberaStAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCsocket *>(dev))->read_LiberaSt(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCsocket *>(dev))->is_LiberaSt_allowed(ty);}
};

//	Attribute LiberaNd class definition
class LiberaNdAttrib: public Tango::SpectrumAttr
{
public:
	LiberaNdAttrib():SpectrumAttr("LiberaNd",
			Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~LiberaNdAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCsocket *>(dev))->read_LiberaNd(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCsocket *>(dev))->is_LiberaNd_allowed(ty);}
};

//	Attribute IlkEnable class definition
class IlkEnableAttrib: public Tango::SpectrumAttr
{
public:
	IlkEnableAttrib():SpectrumAttr("IlkEnable",
			Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~IlkEnableAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCsocket *>(dev))->read_IlkEnable(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCsocket *>(dev))->is_IlkEnable_allowed(ty);}
};

//	Attribute AlOpenId class definition
class AlOpenIdAttrib: public Tango::SpectrumAttr
{
public:
	AlOpenIdAttrib():SpectrumAttr("AlOpenId",
			Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~AlOpenIdAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCsocket *>(dev))->read_AlOpenId(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCsocket *>(dev))->is_AlOpenId_allowed(ty);}
};

//	Attribute AlDiodeDet class definition
class AlDiodeDetAttrib: public Tango::SpectrumAttr
{
public:
	AlDiodeDetAttrib():SpectrumAttr("AlDiodeDet",
			Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~AlDiodeDetAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCsocket *>(dev))->read_AlDiodeDet(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCsocket *>(dev))->is_AlDiodeDet_allowed(ty);}
};

//	Attribute AlLiberaSt class definition
class AlLiberaStAttrib: public Tango::SpectrumAttr
{
public:
	AlLiberaStAttrib():SpectrumAttr("AlLiberaSt",
			Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~AlLiberaStAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCsocket *>(dev))->read_AlLiberaSt(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCsocket *>(dev))->is_AlLiberaSt_allowed(ty);}
};

//	Attribute AlLiberaNd class definition
class AlLiberaNdAttrib: public Tango::SpectrumAttr
{
public:
	AlLiberaNdAttrib():SpectrumAttr("AlLiberaNd",
			Tango::DEV_BOOLEAN, Tango::READ, 16) {};
	~AlLiberaNdAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCsocket *>(dev))->read_AlLiberaNd(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCsocket *>(dev))->is_AlLiberaNd_allowed(ty);}
};

//	Attribute Seq_num class definition
class Seq_numAttrib: public Tango::SpectrumAttr
{
public:
	Seq_numAttrib():SpectrumAttr("Seq_num",
			Tango::DEV_DOUBLE, Tango::READ, 3) {};
	~Seq_numAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PLCsocket *>(dev))->read_Seq_num(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PLCsocket *>(dev))->is_Seq_num_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command Beam_dump class definition
class Beam_dumpClass : public Tango::Command
{
public:
	Beam_dumpClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	Beam_dumpClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~Beam_dumpClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PLCsocket *>(dev))->is_Beam_dump_allowed(any);}
};

//	Command Send_ack class definition
class Send_ackClass : public Tango::Command
{
public:
	Send_ackClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	Send_ackClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~Send_ackClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PLCsocket *>(dev))->is_Send_ack_allowed(any);}
};

//	Command Seq_state_rst class definition
class Seq_state_rstClass : public Tango::Command
{
public:
	Seq_state_rstClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	Seq_state_rstClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~Seq_state_rstClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PLCsocket *>(dev))->is_Seq_state_rst_allowed(any);}
};

//	Command Test_debug class definition
class Test_debugClass : public Tango::Command
{
public:
	Test_debugClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	Test_debugClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~Test_debugClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PLCsocket *>(dev))->is_Test_debug_allowed(any);}
};

//	Command EnableBPM11_2 class definition
class EnableBPM11_2Class : public Tango::Command
{
public:
	EnableBPM11_2Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	EnableBPM11_2Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~EnableBPM11_2Class() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PLCsocket *>(dev))->is_EnableBPM11_2_allowed(any);}
};

//	Command DisableInterlockSCW class definition
class DisableInterlockSCWClass : public Tango::Command
{
public:
	DisableInterlockSCWClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DisableInterlockSCWClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DisableInterlockSCWClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PLCsocket *>(dev))->is_DisableInterlockSCW_allowed(any);}
};

//	Command DisableInterlockID5 class definition
class DisableInterlockID5Class : public Tango::Command
{
public:
	DisableInterlockID5Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DisableInterlockID5Class(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DisableInterlockID5Class() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PLCsocket *>(dev))->is_DisableInterlockID5_allowed(any);}
};


/**
 *	The PLCsocketClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  PLCsocketClass : public Tango::DeviceClass
#else
class PLCsocketClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(PLCsocketClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocketClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static PLCsocketClass *init(const char *);
		static PLCsocketClass *instance();
		~PLCsocketClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		PLCsocketClass(string &);
		static PLCsocketClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	PLCsocket_H
