/*----- PROTECTED REGION ID(PLCsocketStateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        PLCsocketStateMachine.cpp
//
// description : State machine file for the PLCsocket class
//
// project :     PLC interlock server
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: graziano $
//
// $Revision: 1.6 $
// $Date: 2017-02-23 08:42:46 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <PLCsocket.h>

/*----- PROTECTED REGION END -----*/	//	PLCsocket::PLCsocketStateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  ON       |  *
//  FAULT    |  Severe error occurred
//  UNKNOWN  |  Data timestamp is not coherent
//  ALARM    |  *
//  DISABLE  |  Logging DB connection is not available, the server is not logging


namespace PLCsocket_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_IThreshold_allowed()
 *	Description : Execution allowed for IThreshold attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_IThreshold_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for IThreshold attribute in read access.
	/*----- PROTECTED REGION ID(PLCsocket::IThresholdStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::IThresholdStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_Libera3hc_allowed()
 *	Description : Execution allowed for Libera3hc attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_Libera3hc_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Libera3hc attribute in read access.
	/*----- PROTECTED REGION ID(PLCsocket::Libera3hcStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::Libera3hcStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_BeamDumpPLCA10_allowed()
 *	Description : Execution allowed for BeamDumpPLCA10 attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_BeamDumpPLCA10_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for BeamDumpPLCA10 attribute in read access.
	/*----- PROTECTED REGION ID(PLCsocket::BeamDumpPLCA10StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::BeamDumpPLCA10StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_BeamAbi_allowed()
 *	Description : Execution allowed for BeamAbi attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_BeamAbi_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for BeamAbi attribute in read access.
	/*----- PROTECTED REGION ID(PLCsocket::BeamAbiStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::BeamAbiStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_CallPm_allowed()
 *	Description : Execution allowed for CallPm attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_CallPm_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for CallPm attribute in read access.
	/*----- PROTECTED REGION ID(PLCsocket::CallPmStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::CallPmStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_AlIThreshold_allowed()
 *	Description : Execution allowed for AlIThreshold attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_AlIThreshold_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for AlIThreshold attribute in read access.
	/*----- PROTECTED REGION ID(PLCsocket::AlIThresholdStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::AlIThresholdStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_AlLibera3hc_allowed()
 *	Description : Execution allowed for AlLibera3hc attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_AlLibera3hc_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for AlLibera3hc attribute in read access.
	/*----- PROTECTED REGION ID(PLCsocket::AlLibera3hcStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::AlLibera3hcStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_Seq_state_allowed()
 *	Description : Execution allowed for Seq_state attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_Seq_state_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Seq_state attribute in read access.
	/*----- PROTECTED REGION ID(PLCsocket::Seq_stateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::Seq_stateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_EnableBPM11_2_allowed()
 *	Description : Execution allowed for EnableBPM11_2 attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_EnableBPM11_2_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for EnableBPM11_2 attribute in read access.
	/*----- PROTECTED REGION ID(PLCsocket::EnableBPM11_2StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::EnableBPM11_2StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_OpenId_allowed()
 *	Description : Execution allowed for OpenId attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_OpenId_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for OpenId attribute in read access.
	/*----- PROTECTED REGION ID(PLCsocket::OpenIdStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::OpenIdStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_DiodeDet_allowed()
 *	Description : Execution allowed for DiodeDet attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_DiodeDet_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for DiodeDet attribute in read access.
	/*----- PROTECTED REGION ID(PLCsocket::DiodeDetStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::DiodeDetStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_LiberaSt_allowed()
 *	Description : Execution allowed for LiberaSt attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_LiberaSt_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for LiberaSt attribute in read access.
	/*----- PROTECTED REGION ID(PLCsocket::LiberaStStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::LiberaStStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_LiberaNd_allowed()
 *	Description : Execution allowed for LiberaNd attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_LiberaNd_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for LiberaNd attribute in read access.
	/*----- PROTECTED REGION ID(PLCsocket::LiberaNdStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::LiberaNdStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_IlkEnable_allowed()
 *	Description : Execution allowed for IlkEnable attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_IlkEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for IlkEnable attribute in read access.
	/*----- PROTECTED REGION ID(PLCsocket::IlkEnableStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::IlkEnableStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_AlOpenId_allowed()
 *	Description : Execution allowed for AlOpenId attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_AlOpenId_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for AlOpenId attribute in read access.
	/*----- PROTECTED REGION ID(PLCsocket::AlOpenIdStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::AlOpenIdStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_AlDiodeDet_allowed()
 *	Description : Execution allowed for AlDiodeDet attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_AlDiodeDet_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for AlDiodeDet attribute in read access.
	/*----- PROTECTED REGION ID(PLCsocket::AlDiodeDetStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::AlDiodeDetStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_AlLiberaSt_allowed()
 *	Description : Execution allowed for AlLiberaSt attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_AlLiberaSt_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for AlLiberaSt attribute in read access.
	/*----- PROTECTED REGION ID(PLCsocket::AlLiberaStStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::AlLiberaStStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_AlLiberaNd_allowed()
 *	Description : Execution allowed for AlLiberaNd attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_AlLiberaNd_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for AlLiberaNd attribute in read access.
	/*----- PROTECTED REGION ID(PLCsocket::AlLiberaNdStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::AlLiberaNdStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_Seq_num_allowed()
 *	Description : Execution allowed for Seq_num attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_Seq_num_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Seq_num attribute in read access.
	/*----- PROTECTED REGION ID(PLCsocket::Seq_numStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::Seq_numStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_Beam_dump_allowed()
 *	Description : Execution allowed for Beam_dump attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_Beam_dump_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Beam_dump command.
	/*----- PROTECTED REGION ID(PLCsocket::Beam_dumpStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::Beam_dumpStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_Send_ack_allowed()
 *	Description : Execution allowed for Send_ack attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_Send_ack_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Send_ack command.
	/*----- PROTECTED REGION ID(PLCsocket::Send_ackStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::Send_ackStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_Seq_state_rst_allowed()
 *	Description : Execution allowed for Seq_state_rst attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_Seq_state_rst_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Seq_state_rst command.
	/*----- PROTECTED REGION ID(PLCsocket::Seq_state_rstStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::Seq_state_rstStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_Test_debug_allowed()
 *	Description : Execution allowed for Test_debug attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_Test_debug_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Test_debug command.
	/*----- PROTECTED REGION ID(PLCsocket::Test_debugStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::Test_debugStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_EnableBPM11_2_allowed()
 *	Description : Execution allowed for EnableBPM11_2 attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_EnableBPM11_2_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for EnableBPM11_2 command.
	/*----- PROTECTED REGION ID(PLCsocket::EnableBPM11_2StateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::EnableBPM11_2StateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_DisableInterlockSCW_allowed()
 *	Description : Execution allowed for DisableInterlockSCW attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_DisableInterlockSCW_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DisableInterlockSCW command.
	/*----- PROTECTED REGION ID(PLCsocket::DisableInterlockSCWStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::DisableInterlockSCWStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PLCsocket::is_DisableInterlockID5_allowed()
 *	Description : Execution allowed for DisableInterlockID5 attribute
 */
//--------------------------------------------------------
bool PLCsocket::is_DisableInterlockID5_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DisableInterlockID5 command.
	/*----- PROTECTED REGION ID(PLCsocket::DisableInterlockID5StateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PLCsocket::DisableInterlockID5StateAllowed
	return true;
}


/*----- PROTECTED REGION ID(PLCsocket::PLCsocketStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	PLCsocket::PLCsocketStateAllowed.AdditionalMethods

}	//	End of namespace
