/*
 * plcsrvthread.h
 *
 *	17.01.07 - SF: first release 
 *	 
 */ 

#ifndef PLCSRVTHREAD_H
#define PLCSRVTHREAD_H

#include <omnithread.h>
#include <tango.h>
#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>    
#include <string.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <arpa/inet.h>
#include <signal.h>
#include <netdb.h>    
#include <PLCsocket.h>

#define SRV_BUF_LEN 2048
//number of socket accepted by the server
const short MAX_NUM_SOCK=1; ///

class plcsrvthread : public omni_thread, public Tango::LogAdapter{
	
	private:
		PLCsocket_ns::PLCsocket *t_PLCsocket;		
				
	public:
		
		plcsrvthread(PLCsocket_ns::PLCsocket *s):Tango::LogAdapter(s){
			t_PLCsocket = s;
		};
		
		~plcsrvthread() {
		};
		void StartUndetached(){
			start_undetached();
		}
		void *run_undetached(void *);	

	protected:
	
		int errcount;
		struct timeval _pre, _post;
		char frame2[SRV_BUF_LEN];
		u_short olddata;
		u_long first_read;
		PLCsocket_ns::tstamp_t time_before;
		PLCsocket_ns::intlck_libera local_mesg;
		
   		struct sembuf operations[1];
   		int retval;
   		int id;
   
		Tango::DeviceProxy *mydevice;
		Tango::DeviceAttribute arl;
	
	
		int cnt, server_started;           
	      
		struct sockaddr_in myname;  
		struct sockaddr_in *nptr;   
		struct sockaddr    addr;    

   
		char buf[SRV_BUF_LEN];

		void Srv_Prepare(void);
		uint16_t plc_swap(uint16_t in);
		uint32_t plc_swaplong(uint32_t in);
				
};	/* end class plcsrvthread() */



#endif

/* EOF */
